%global scala_short_version 2.10
Name:          jackson-module-scala
Version:       2.5.0
Release:       1%{?dist}
Summary:       Add-on module for Jackson to support Scala-specific data-types
License:       ASL 2.0
URL:           http://wiki.fasterxml.com/JacksonModuleScala
Source0:       https://github.com/FasterXML/jackson-module-scala/archive/%{name}-%{version}.tar.gz
# Default use sbt
Source1:       http://repo1.maven.org/maven2/com/fasterxml/jackson/module/%{name}_%{scala_short_version}/%{version}/%{name}_%{scala_short_version}-%{version}.pom

BuildRequires: maven-local
BuildRequires: mvn(com.fasterxml.jackson.core:jackson-annotations)
BuildRequires: mvn(com.fasterxml.jackson.core:jackson-core)
BuildRequires: mvn(com.fasterxml.jackson.core:jackson-databind)
BuildRequires: mvn(com.thoughtworks.paranamer:paranamer)
BuildRequires: mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-antrun-plugin)
BuildRequires: mvn(org.scala-lang:scala-compiler)
BuildRequires: mvn(org.scala-lang:scala-library)
BuildRequires: mvn(org.scala-lang:scala-reflect)

# BuildRequires: mvn(com.google.code.findbugs:jsr305)
# BuildRequires: mvn(com.google.guava:guava)

%if 0
# Test deps
BuildRequires: mvn(com.fasterxml.jackson.datatype:jackson-datatype-guava)
BuildRequires: mvn(com.fasterxml.jackson.module:jackson-module-jsonSchema)
BuildRequires: mvn(junit:junit)
# Not available deps [*]
# https://bugzilla.redhat.com/show_bug.cgi?id=1039301
BuildRequires: mvn(com.fasterxml.jackson.datatype:jackson-datatype-joda)
BuildRequires: mvn(org.scalatest:scalatest_%{scala_short_version}:2.2.1)
%endif

BuildArch:     noarch

%description
The Jackson Scala Module is an extension for the
Jackson JSON Processor that adds data-binding support
for Scala native types and collections.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-%{name}-%{version}
# Cleanup
find -name '*.class' -print -delete
find -name '*.jar' -print -delete

cp -p %{SOURCE1} pom.xml
%pom_add_plugin org.apache.maven.plugins:maven-antrun-plugin:1.7 . '
<executions>
  <execution>
    <id>compile</id>
    <phase>process-sources</phase>
    <configuration>
      <tasks>
        <property name="build.compiler" value="extJavac"/>
        <taskdef resource="scala/tools/ant/antlib.xml" classpathref="maven.compile.classpath"/>
        <mkdir dir="target/classes"/>
        <scalac srcdir="src/main" destdir="target/classes" classpathref="maven.compile.classpath" encoding="UTF-8">
          <include name="**/*.*"/>
        </scalac>
      </tasks>
    </configuration>
      <goals>
        <goal>run</goal>
      </goals>
  </execution>
</executions>
<dependencies>
  <dependency>
      <groupId>org.scala-lang</groupId>
      <artifactId>scala-compiler</artifactId>
      <version>2.10.4</version>
  </dependency>
</dependencies>'

%pom_add_plugin org.apache.felix:maven-bundle-plugin:2.3.7 . "
<extensions>true</extensions>
<configuration>
  <instructions>
    <Bundle-Name>\${project.groupId}.jackson.module.scala</Bundle-Name>
    <Bundle-SymbolicName>\${project.groupId}.jackson.module.scala</Bundle-SymbolicName>
    <Bundle-Version>\${project.version}</Bundle-Version>
  </instructions>
</configuration>
<executions>
  <execution>
    <id>bundle-manifest</id>
    <phase>process-classes</phase>
    <goals>
      <goal>manifest</goal>
    </goals>
  </execution>
</executions>"

sed -i 's/\r//' src/main/resources/META-INF/LICENSE
cp -p src/main/resources/META-INF/LICENSE .
# sbt generate this crap
mkdir -p src/main/resources/com/fasterxml/jackson/module/scala
cat > src/main/resources/com/fasterxml/jackson/module/scala/build.properties << EOF
version=%{version}
groupId=com.fasterxml.jackson.module
artifactId=%{name}
EOF

%build

# Not able to run test suite, not available deps [*]
%mvn_build -f

%install
%mvn_install

%files -f .mfiles
%doc README.md notes release-notes
%license LICENSE

%files javadoc -f .mfiles-javadoc
# https://github.com/FasterXML/jackson-module-scala/issues/130
%license LICENSE

%changelog
* Thu Jul 30 2015 gil cattaneo <puntogil@libero.it> 2.5.0-1
- update to 2.5.0

* Sat Feb 15 2014 gil cattaneo <puntogil@libero.it> 2.2.2-1
- initial rpm
